format PE64 GUI 6.0
entry WinMain

include 'win64a.inc'

  IDR_ICON        = 10h

  IDR_MAINMENU    = 100h
  IDR_CHILDMENU   = 101h
;File
  IDM_NEW         = 1100h
  IDM_CLOSE       = 1F00h
  IDM_EXIT        = 1FFFh
;Window
  IDM_TILEHORZ    = 0E001h
  IDM_TILEVERT    = 0E002h
  IDM_CASCADE     = 0E004h
;Help
  IDM_ABOUT       = 0F000h

  IDM_FIRSTCHILD  = 10000h

section '.data' data readable writeable
;Class Names
    szFrameClass db 'MDIFrame',0
    szClientClass db 'MDICLIENT',0                ;Pre-defined by System
    szChildClass db 'MDIChild',0
;Window Captions
    szFrameTitle db 'Win64 fasm MDI Demo',0
    szChildTitle db 'MDI Child',0
;Window Handles
    hInst dq ?
    hWndFrame dq ?
    hWndClient dq ?
    hWndChild dq ?
;Menu Handles
    hMenu dq ?
    hMainMenu dq ?
    hChildMenu dq ?
    hMainSubMenu dq ?
    hChildSubMenu dq ?
;Structures
    WndClass WNDCLASSEX
    msg MSG
    MDICreate MDICREATESTRUCT
    ClientCreate CLIENTCREATESTRUCT
;Info Messages
    szHello db 'Hello, World!',0
    szAbout db '. .   Windows 95',0Ah,0Dh,\
    ' 18  ',0
;Prompt Messages
    szClose db 'Close Active Child Window?',0
    szExit db 'Exit and Close All Child Windows?',0
;Error Messages
    szMainErr db 'Error in WinMain',0
    szWndErr db 'Error in FrameWndProc',0
    szChildErr db 'Error in ChildWndProc',0

;**************************************************************************************************
section '.text' code readable executable

WinMain:
;====================================================================
;proc WinMain hInst:QWORD,hPrevInst:QWORD,CmdLine:QWORD,CmdShow:DWORD
;====================================================================
    sub rsp, 8 ;Make stack dqword aligned

    invoke GetModuleHandle,0
    mov [hInst],rax
    test rax,rax
    jz errWinMain

;Register the Frame Window Class
    ;WndClass.cbSize = sizeof(WndClass);
        mov [WndClass.cbSize], 50h
    ;WndClass.style = CS_HREDRAW | CS_VREDRAW;
        mov [WndClass.style], 3
    ;WndClass.lpfnWndProc = FrameWndProc;
        mov rax, FrameWndProc
        mov [WndClass.lpfnWndProc], rax
    ;WndClass.cbClsExtra = 0;
        mov [WndClass.cbClsExtra], 0
    ;WndClass.cbWndExtra = 0;
        mov [WndClass.cbWndExtra], 0
    ;WndClass.hInstance = hInstance;
        mov rax, [hInst]
        mov [WndClass.hInstance], rax
    ;WndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
        invoke LoadIcon, 0, 7F00h
        mov [WndClass.hIcon], rax
        mov [WndClass.hIconSm], rax
    ;WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
        invoke LoadCursor, 0, 7F00h
        mov [WndClass.hCursor], rax
    ;WndClass.hbrBackground =(HBRUSH)(COLOR_APPWORKSPACE + 1);
        mov [WndClass.hbrBackground], 0Dh
    ;WndClass.lpszMenuName = NULL;
        mov [WndClass.lpszMenuName], 0
    ;WndClass.lpszClassName = szFrameClass;
        mov rax, szFrameClass
        mov [WndClass.lpszClassName], rax
    ;WndClass.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
        ;Already done
    invoke RegisterClassEx, WndClass
    test rax,rax
    jz errWinMain
;Register the Child Window Class
;There is no need to refill WNDCLASSEX again
;Just change some values
    ;WndClass.lpfnWndProc = HelloWndProc;
        mov rax, ChildWndProc
        mov [WndClass.lpfnWndProc], rax
    ;WndClass.cbWndExtra = sizeof(HANDLE);
        mov [WndClass.cbWndExtra], 8
    ;WndClass.hbrBackground =(HBRUSH) GetStockObject(WHITE_BRUSH);
        invoke GetStockObject, 0
        mov [WndClass.hbrBackground], rax
    ;WndClass.lpszClassName = szChildClass;
        mov rax, szChildClass
        mov [WndClass.lpszClassName], rax
    invoke RegisterClassEx, WndClass
    test rax,rax
    jz errWinMain

;Get Menu Handles
    invoke LoadMenu, [hInst],IDR_MAINMENU
    mov [hMainMenu], rax
    invoke LoadMenu, [hInst],IDR_CHILDMENU
    mov [hChildMenu], rax
    invoke GetSubMenu, [hMainMenu], MainMenu
    mov [hMainSubMenu], rax
    invoke GetSubMenu, [hChildMenu], ChildMenu
    mov [hChildSubMenu], rax

;Create the Frame Window
invoke CreateWindowEx, 0, szFrameClass, szFrameTitle,\
       WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,\
       CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,\
       NULL, [hMainMenu], [hInst], NULL
    mov [hWndFrame], rax
    test rax,rax
    jz errWinMain

;Get Client Window Handle
    invoke GetWindow, [hWndFrame], GW_CHILD
    mov [hWndClient], rax

    invoke ShowWindow, [hWndFrame], 1 ;nCmdShow = SW_SHOWNORMAL = 1
    invoke UpdateWindow, [hWndFrame]

;Enter the Loop
MsgLoop:
    invoke GetMessage, msg, 0, 0, 0
    cmp rax, 0
        je CleanUp
    invoke TranslateMDISysAccel, [hWndClient], msg
    cmp rax,0
        jne MsgLoop
    invoke TranslateMessage, msg
    invoke DispatchMessage, msg
jmp MsgLoop

errWinMain:
    invoke  MessageBox, 0, szMainErr, szFrameTitle, 30h ;MB_ICONERROR+MB_OK

CleanUp:
    invoke DestroyMenu, [hChildMenu]

;return msg.wParam;
EndAll:
    invoke ExitProcess, [msg.wParam]



;===============================================================
;WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;===============================================================
proc FrameWndProc hWnd,uMsg,wParam,lParam

;Store Values retrieved by DispatchMessageA
    mov [hWnd], rcx
    mov [uMsg], rdx
    mov [wParam], r8
    mov [lParam], r9

;Window Messages processing
    cmp rdx, WM_CREATE ;1
        je wmFrameCreate
    cmp rdx, WM_COMMAND ;0x0111
        je wmFrameCommand
    cmp rdx, WM_CLOSE ;0x0010
        je wmFrameClose
    cmp rdx, WM_DESTROY ;2
        je wmFrameDestroy
    jmp defFrameWndProc

wmFrameCreate:
    ;Create the Client Window
    mov rax, [hMainSubMenu]
    mov [ClientCreate.hWindowMenu], rax
    mov [ClientCreate.idFirstChild], IDM_FIRSTCHILD
    invoke CreateWindowEx, 0, szClientClass, 0,\
           WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,\
           [hWnd], 0, [hInst], ClientCreate
    mov [hWndClient], rax
test rax,rax
jz errFrame
    jmp finFrameWndProc

wmFrameCommand:
    cmp r9, 0      ;lParam
        jne finFrameWndProc
    ;Distributing with respect to wParam
        cmp r8, IDM_NEW
            je idmFrameNew
        cmp r8, IDM_CLOSE
            je idmFrameClose
        cmp r8, IDM_EXIT
            je idmFrameExit
        cmp r8, IDM_TILEHORZ
            je idmFrameTileHorz
        cmp r8, IDM_TILEVERT
            je idmFrameTileVert
        cmp r8, IDM_CASCADE
            je idmFrameCascade
        cmp r8, IDM_ABOUT
            je idmFrameAbout
        jmp defFrameCmd

    idmFrameNew:
        ;Initialize the MDICREATESTRUCT
            mov rax, szChildClass
            mov [MDICreate.szClass], rax
            mov rax, szChildTitle
            mov [MDICreate.szTitle], rax
            mov rax, [hInst]
            mov [MDICreate.hOwner], rax
            mov [MDICreate.x], CW_USEDEFAULT
            mov [MDICreate.y], CW_USEDEFAULT
            mov [MDICreate.cx], CW_USEDEFAULT
            mov [MDICreate.cy], CW_USEDEFAULT
            mov [MDICreate.style], 0
            mov [MDICreate.lParam], 0
        invoke SendMessage, [hWndClient], WM_MDICREATE, 0, MDICreate
        mov [hWndChild], rax
test rax,rax
jz errFrame
        jmp finFrameWndProc

    idmFrameClose:
        invoke SendMessage, [hWndClient], WM_MDIGETACTIVE, 0, 0
        mov [hWndChild], rax
        invoke SendMessage, [hWndChild], WM_CLOSE, 0, 0
        jmp finFrameWndProc

    idmFrameExit:
        invoke SendMessage, [hWnd], WM_CLOSE, 0, 0
        jmp finFrameWndProc

    idmFrameTileHorz:
        invoke SendMessage, [hWndClient], WM_MDITILE, MDITILE_HORIZONTAL, 0
        jmp finFrameWndProc

    idmFrameTileVert:
        invoke SendMessage, [hWndClient], WM_MDITILE, MDITILE_VERTICAL, 0
        jmp finFrameWndProc

    idmFrameArrange:
        invoke SendMessage, [hWndClient], WM_MDIICONARRANGE, 0, 0
        jmp finFrameWndProc

    idmFrameCascade:
        invoke SendMessage, [hWndClient], WM_MDICASCADE, MDITILE_SKIPDISABLED, 0
        jmp finFrameWndProc

    idmFrameAbout:
        invoke MessageBox, [hWnd], szAbout, szFrameTitle, 40h
        jmp finFrameWndProc

     defFrameCmd:
        ;Pass to active child...
        invoke SendMessage, [hWndClient], WM_MDIGETACTIVE, 0, 0
        mov [hWndChild], rax
        invoke IsWindow, [hWndChild]
        cmp rax, 0
            jne defFrameWndProc
        invoke SendMessage, [hWndChild], WM_COMMAND, [wParam], [lParam]
        ;...and then to DefFrameProc
        jne defFrameWndProc

wmFrameClose:
    invoke MessageBox, [hWnd], szExit, szChildTitle, MB_YESNO
    cmp rax, IDYES
        jne finFrameWndProc
    invoke SendMessage, [hWnd], WM_DESTROY, 0, 0
    jmp finFrameWndProc

wmFrameDestroy:
    invoke PostQuitMessage, 0
    jmp defFrameWndProc

defFrameWndProc:
    invoke DefFrameProc, [hWnd],[hWndClient],[uMsg],[wParam],[lParam]
    jmp finFrameWndProc

errFrame:
    invoke MessageBox, [hWnd], szWndErr, szFrameTitle, MB_ICONERROR+MB_OK

finFrameWndProc:
    ret
endp    ;WndProc



;================================================================
;ChildProc proc hChild:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
;================================================================
proc ChildWndProc hWnd, uMsg, wParam, lParam

;Store Values retrieved by DispatchMessageA
     mov [hWnd], rcx
     mov [uMsg], rdx
     mov [wParam], r8
     mov [lParam], r9

;Distributing with respect to uMsg
cmp rdx, WM_CREATE ;1
    je wmChildCreate
cmp rdx, WM_MDIACTIVATE ;0x0222
    je wmChildActivate
cmp rdx, WM_LBUTTONUP ;0x0202
    je wmChildLButtonUp
cmp rdx, WM_CLOSE ;0x0010
    je wmChildClose
jmp defChildWndProc

wmChildCreate:
    nop
    jmp defChildWndProc

wmChildActivate:
    cmp r9, [hWnd] ;lParam == hWndChild
        jne notChild
    invoke SendMessage, [hWndClient], WM_MDISETMENU, [hChildMenu], [hChildSubMenu]
    jmp ChildReDrawMenu
    notChild: ;lParam != hWndChild
        invoke SendMessage,[hWndClient], WM_MDISETMENU, [hMainMenu], [hMainSubMenu]
    ChildReDrawMenu:
        invoke DrawMenuBar, [hWndFrame]
    jmp finChildWndProc

wmChildLButtonUp:
     invoke MessageBox, [hWnd], szHello, szChildTitle, 30h ;MB_ICONERROR+MB_OK
     jmp finChildWndProc

wmChildClose:
    invoke MessageBox, [hWnd], szClose, szChildTitle, MB_YESNO
    cmp rax, IDYES
        jne finChildWndProc
    invoke SendMessage, [hWndClient], WM_MDIDESTROY, [hWnd], 0
    jmp finChildWndProc

defChildWndProc:
    invoke DefMDIChildProc, [hWnd], [uMsg], [wParam], [lParam]
    jmp finChildWndProc

errChild:
    invoke  MessageBox, [hWnd], szChildErr, szChildTitle, 30h ;MB_ICONERROR+MB_OK

finChildWndProc:
    ret
endp    ;ChildProc

;**************************************************************************************************
section '.idata' import data readable writeable

    library kernel32,'KERNEL32.DLL',\
            user32,'USER32.DLL',\
            gdi32, 'GDI32.dll'

    include 'api\kernel32.inc'
    include 'api\user32.inc'
    include 'api\gdi32.inc'

section '.rsrc' resource data readable

    ;resource directory

    directory RT_MENU,menus,\
              RT_ICON,icons,\
              RT_GROUP_ICON,group_icons,\
              RT_VERSION,versions

    ;resource subdirectories

    resource menus,\
             IDR_MAINMENU, LANG_ENGLISH+SUBLANG_DEFAULT, MainMenu,\
             IDR_CHILDMENU, LANG_ENGLISH+SUBLANG_DEFAULT, ChildMenu

    menu MainMenu
         menuitem '&File', 0, MFR_POPUP
                  menuitem '&New', IDM_NEW
                  menuseparator
                  menuitem 'E&xit', IDM_EXIT, MFR_END
         menuitem '&Help', 0, MFR_POPUP + MFR_END
                  menuitem '&About...', IDM_ABOUT,MFR_END

    menu ChildMenu
         menuitem '&File', 0, MFR_POPUP
                  menuitem '&New', IDM_NEW
                  menuitem '&Close', IDM_CLOSE
                  ;menuitem 'Close &All', IDM_CLOSEALL
                  menuseparator
                  menuitem 'E&xit', IDM_EXIT,MFR_END
         menuitem '&Window', 0, MFR_POPUP
                  menuitem 'Tile Horizontal', IDM_TILEHORZ
                  menuitem 'Tile Vertical', IDM_TILEVERT
                  ;menuitem 'Arrange', IDM_ARRANGE
                  menuitem 'Cascade', IDM_CASCADE, MFR_END
         menuitem '&Help', 0, MFR_POPUP + MFR_END
                  menuitem '&About...', IDM_ABOUT, MFR_END

    resource icons,\
             1,LANG_NEUTRAL,icon_data

    resource group_icons,\
             IDR_ICON,LANG_NEUTRAL,main_icon

    icon main_icon,icon_data,'minipad.ico'

    resource versions,\
             1,LANG_NEUTRAL,version

    versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_RUSSIAN+SUBLANG_DEFAULT,0,\
                'FileDescription','Multiple Document Interface Template',\
                'LegalCopyright','All rights spread among community',\
                'FileVersion','0.33',\
                'ProductVersion','0.33',\
                'OriginalFilename','fasm64MDI_xx.exe'